Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# Histogram Class Reference

A struct to represent histograms. More...

`#include <Histogram.h>`

List of all members.

## Public Types
enum | HistogramID { noID, imageIntensityY, imageIntensityU, imageIntensityV, scanLineIntensityY, scanLineIntensityU, scanLineIntensityV, colorFrequency, lengthOfSegments, numberOfHistogramIDs }
## Public Member Functions
| Histogram ()
| Histogram (HistogramID id)
void | init ()
void | init (int numberOfEntries)
void | add (int index)
void | setID (HistogramID id)
int | getValue (int index)
int | getNumberOfEntries ()
HistogramID | getHistogramID ()
Histogram & | operator= (const Histogram &other)
double | getAverage ()
double | getAverageFrequencyOverAllEntries ()
double | getAverageFrequencyOverUsedEntries ()
void | analyseClusters ()
int | getNumberOfClusters ()
int | getBeginOfCluster (int index)
int | getEndOfCluster (int index)
## Static Public Member Functions
const char * | getName (HistogramID histogramID)
DebugKeyTable::debugKeyID | getDebugKeyID (HistogramID histogramID)
## Private Types
enum | { maxNumberOfEntries = 256 }
## Private Attributes
int | value [maxNumberOfEntries]
int | numberOfEntries
HistogramID | histogramID
int | numberOfAddedEntries
int | sum
int | numberOfClusters
int | beginOfCluster [maxNumberOfEntries]
int | endOfCluster [maxNumberOfEntries]

## Detailed Description

A struct to represent histograms.

Definition at line 20 of file Histogram.h.

## Member Enumeration Documentation

enum Histogram::HistogramID

  | Enumeration values:
  noID |
  imageIntensityY |
  imageIntensityU |
  imageIntensityV |
  scanLineIntensityY |
  scanLineIntensityU |
  scanLineIntensityV |
  colorFrequency |
  lengthOfSegments |
  numberOfHistogramIDs |
Definition at line 23 of file Histogram.h. Referenced by getHistogramID().

anonymous enum`[private]`

  | Enumeration values:
  maxNumberOfEntries |
Definition at line 108 of file Histogram.h.

## Constructor & Destructor Documentation

Histogram::Histogram | ( |  | ) | `[inline]`

| Definition at line 75 of file Histogram.h. References histogramID, init(), and noID.

Here is the call graph for this function:

Histogram::Histogram | ( | HistogramID | id | ) | `[inline]`

| Definition at line 76 of file Histogram.h. References histogramID, and init().

Here is the call graph for this function:

## Member Function Documentation

const char* Histogram::getName | ( | HistogramID | histogramID | ) | `[inline, static]`

| Definition at line 37 of file Histogram.h. References imageIntensityU, imageIntensityV, imageIntensityY, lengthOfSegments, noID, scanLineIntensityU, scanLineIntensityV, and scanLineIntensityY.

DebugKeyTable::debugKeyID Histogram::getDebugKeyID | ( | HistogramID | histogramID | ) | `[inline, static]`

| Definition at line 54 of file Histogram.h. References ASSERT, imageIntensityU, imageIntensityV, imageIntensityY, lengthOfSegments, scanLineIntensityU, scanLineIntensityV, and scanLineIntensityY.

void Histogram::init | ( |  | ) |

| Definition at line 11 of file Histogram.cpp. Referenced by Histogram().

void Histogram::init | ( | int | numberOfEntries | ) |

| Definition at line 16 of file Histogram.cpp. References numberOfAddedEntries, sum, and value.

void Histogram::add | ( | int | index | ) |

| Definition at line 25 of file Histogram.cpp. References numberOfAddedEntries, sum, and value.

void Histogram::setID | ( | HistogramID | id | ) | `[inline]`

| Definition at line 81 of file Histogram.h. References histogramID.

int Histogram::getValue | ( | int | index | ) |

| Definition at line 34 of file Histogram.cpp. References value.

int Histogram::getNumberOfEntries | ( |  | ) |

| Definition at line 40 of file Histogram.cpp.

Histogram::HistogramID Histogram::getHistogramID | ( |  | ) |

| Definition at line 45 of file Histogram.cpp. References histogramID, and HistogramID.

Histogram& Histogram::operator= | ( | const Histogram & | other | ) | `[inline]`

| Definition at line 88 of file Histogram.h. References histogramID, numberOfAddedEntries, numberOfEntries, sum, and value.

double Histogram::getAverage | ( |  | ) |

| Definition at line 52 of file Histogram.cpp. References numberOfAddedEntries, and sum.

double Histogram::getAverageFrequencyOverAllEntries | ( |  | ) |

| Definition at line 57 of file Histogram.cpp. References numberOfAddedEntries. Referenced by analyseClusters().

double Histogram::getAverageFrequencyOverUsedEntries | ( |  | ) |

| Definition at line 62 of file Histogram.cpp. References numberOfAddedEntries, and value.

void Histogram::analyseClusters | ( |  | ) |

| Definition at line 69 of file Histogram.cpp. References beginOfCluster, endOfCluster, getAverageFrequencyOverAllEntries(), numberOfClusters, and value.

Here is the call graph for this function:

int Histogram::getNumberOfClusters | ( |  | ) |

| Definition at line 123 of file Histogram.cpp. References numberOfClusters.

int Histogram::getBeginOfCluster | ( | int | index | ) |

| Definition at line 128 of file Histogram.cpp. References beginOfCluster.

int Histogram::getEndOfCluster | ( | int | index | ) |

| Definition at line 133 of file Histogram.cpp. References endOfCluster.

## Member Data Documentation

int Histogram::value[maxNumberOfEntries]`[private]`

| Definition at line 109 of file Histogram.h. Referenced by add(), analyseClusters(), getAverageFrequencyOverUsedEntries(), getValue(), init(), and operator=().

int Histogram::numberOfEntries`[private]`

| Definition at line 110 of file Histogram.h. Referenced by operator=().

HistogramID Histogram::histogramID`[private]`

| Definition at line 111 of file Histogram.h. Referenced by getHistogramID(), Histogram(), operator=(), and setID().

int Histogram::numberOfAddedEntries`[private]`

| Definition at line 113 of file Histogram.h. Referenced by add(), getAverage(), getAverageFrequencyOverAllEntries(), getAverageFrequencyOverUsedEntries(), init(), and operator=().

int Histogram::sum`[private]`

| Definition at line 114 of file Histogram.h. Referenced by add(), getAverage(), init(), and operator=().

int Histogram::numberOfClusters`[private]`

| Definition at line 116 of file Histogram.h. Referenced by analyseClusters(), and getNumberOfClusters().

int Histogram::beginOfCluster[maxNumberOfEntries]`[private]`

| Definition at line 117 of file Histogram.h. Referenced by analyseClusters(), and getBeginOfCluster().

int Histogram::endOfCluster[maxNumberOfEntries]`[private]`

| Definition at line 118 of file Histogram.h. Referenced by analyseClusters(), and getEndOfCluster().

The documentation for this class was generated from the following files:

- Tools/Math/Histogram.h
- Tools/Math/Histogram.cpp